package utils;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;
import java.util.Vector;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import com.sun.org.apache.bcel.internal.generic.NEW;

//-1 in file "scores" means the user not in users(t_x) .. eq. not scoring


public class Score {
	
	Vector<String> users= new Vector<String>();
	Vector<String> elements=new Vector<String>();
	Vector<String> contexts=new Vector<String>();
	Vector<ContextElems> contextsElems=new Vector<ContextElems>();
	Vector<LocalContext> localContexts=new Vector<LocalContext>();
	Vector<BreakPos> breakPos=new Vector<BreakPos>();
	Vector<ElemLoc> elemLocs=new Vector<ElemLoc>();
	Vector<ElemLoc> elemScreenPos=new Vector<ElemLoc>();
	Vector<View> views=new Vector<View>();
	Vector<BreakPos> mouseHes=new Vector<BreakPos>();
	
	ScorList scorList=new ScorList();
	int periods;
	
	public Score(){
		
		//enregistrements des primitives
		users=loader("users", users);
		elements=loader("elements", elements);
		contexts=loader("contexts", contexts);
		
		periods=6;
		
		//chargement des élements des différents contextes
		Vector<String> contextElemsFile=new Vector<String>();
		contextElemsFile=loader("elems_in_contexts", contextElemsFile);
		for (int i=0;i<periods;i++) {
			for(int j=0;j<contexts.size();j++){
				String line= contextElemsFile.get(i*contexts.size()+j);
				ContextElems ct=new ContextElems(contexts.get(j), i);
				line=line.replace("{","");
				line=line.replace("}","");
				StringTokenizer tokens=new StringTokenizer(line,",");
				while(tokens.hasMoreTokens()){
					ct.add((String)tokens.nextElement());
				}
				contextsElems.add(ct);
			}
		}
		
		//chargement des utilisateurs des contextes
		Vector<String> localContextFile=new Vector<String>();
		localContextFile=loader("local_context_for_user", localContextFile);
		for (int i=0;i<periods;i++) {
			for(int j=0;j<users.size();j++){
				LocalContext ct=new LocalContext(users.get(j), i);
				ct.set(localContextFile.get(i*users.size()+j));
				localContexts.add(ct);
			}
		}
		
		//chargement des localisations géo des elements au cours du temps
		Vector<String> elemLocFile=new Vector<String>();
		elemLocFile=loader("elems_locations", elemLocFile);
		for (int i=0;i<periods;i++) {
			for(int j=0;j<elements.size();j++){
				ElemLoc el=new ElemLoc(elements.get(j), i);
				String line= elemLocFile.get(i*elements.size()+j);
				StringTokenizer tokens=new StringTokenizer(line,",");
				el.locX=Integer.parseInt(tokens.nextToken());
				el.locY=Integer.parseInt(tokens.nextToken());
				elemLocs.add(el);
			}
		}
		
		//chargement des lieux et durées de pauses des utilisateurs
		Vector<String> userPauseFile=new Vector<String>();
		userPauseFile=loader("users_pauses", userPauseFile);
		for (int i=0;i<periods;i++) {
			for(int j=0;j<users.size();j++){
				String line= userPauseFile.get(i*users.size()+j);
				BreakPos bp=new BreakPos(users.get(j), i);
				line=line.replace("{","");
				line=line.replace("}","");
				line=line.replace(" ","");
				line=line.replace("\t","");
				StringTokenizer tokens=new StringTokenizer(line,"|");
				Vector<Pause> pauses=new Vector<Pause>();
				while(tokens.hasMoreTokens()){
					String str=tokens.nextToken();
					str=str.replace("(","");
					str=str.replace(")","");
					str=str.replace(" ","");
					str=str.replace("\t","");
					StringTokenizer tokpos=new StringTokenizer(str,",");
					Pause p=new Pause(	Integer.parseInt(tokpos.nextToken()),
										Integer.parseInt(tokpos.nextToken()),
										Integer.parseInt(tokpos.nextToken()));
					pauses.add(p);
				}
				bp.set(pauses);
				breakPos.add(bp);
			}
		}
		
		//chargement des poids de la vue affichée a l'ecran
		Vector<String> viewFile=new Vector<String>();
		viewFile=loader("views_weights", viewFile);
		for (int i=0;i<periods;i++) {
			for(int j=0;j<users.size();j++){
				View vi=new View(users.get(j), i);
				String line=viewFile.get(i*contexts.size()+j);
				line=line.replace(" ","");
				line=line.replace("\t","");
				vi.set(Integer.parseInt(line));
				views.add(vi);
			}
		}
		
		//chargement des position des éléments a l'ecran.
		elemLocFile=new Vector<String>();
		elemLocFile=loader("elems_screen_pos", elemLocFile);
		for (int i=0;i<periods;i++) {
			for(int j=0;j<elements.size();j++){
				ElemLoc el=new ElemLoc(elements.get(j), i);
				String line= elemLocFile.get(i*elements.size()+j);
				line=line.replace(" ","");
				line=line.replace("\t","");
				StringTokenizer tokens=new StringTokenizer(line,",");
				el.locX=Integer.parseInt(tokens.nextToken());
				el.locY=Integer.parseInt(tokens.nextToken());
				elemScreenPos.add(el);
			}
		}

		//chargement des position des clics des utilisateurs ...
		userPauseFile=new Vector<String>();
		userPauseFile=loader("mouse_click_pauses", userPauseFile);
		for (int i=0;i<periods;i++) {
			for(int j=0;j<users.size();j++){
				String line= userPauseFile.get(i*users.size()+j);
				BreakPos bp=new BreakPos(users.get(j), i);
				line=line.replace("{","");
				line=line.replace("}","");
				line=line.replace(" ","");
				line=line.replace("\t","");
				StringTokenizer tokens=new StringTokenizer(line,"|");
				Vector<Pause> pauses=new Vector<Pause>();
				while(tokens.hasMoreTokens()){
					String str=tokens.nextToken();
					str=str.replace("(","");
					str=str.replace(")","");
					str=str.replace(" ","");
					str=str.replace("\t","");
					StringTokenizer tokpos=new StringTokenizer(str,",");
					Pause p=new Pause(	Integer.parseInt(tokpos.nextToken()),
										Integer.parseInt(tokpos.nextToken()),
										Integer.parseInt(tokpos.nextToken()));
					pauses.add(p);
				}
				bp.set(pauses);
				mouseHes.add(bp);
			}
		}
		
		//debug ...
//		for (String user : users) {
//			for (String elem : elements) {
//				double eX=0,eY=0;
//				for (ElemLoc elmloc : elemScreenPos) {
//					if(elmloc.elem.equals(elem) && elmloc.t==1){
//						eX=elmloc.locX;
//						eY=elmloc.locY;
//						break;
//					}
//				}
//				System.out.print(user+":"+elem+"("+eX+","+eY+") -> ");
//				for (Pause ps : mouseHes(user, "ec1", 1)) {
//					System.out.print(ps.toString()+" d()="+(Math.round(Math.sqrt(Math.pow(ps.locX-eX,2)+Math.pow(ps.locY-eY,2))*1000)/1000)+"\t");
//				}
//				System.out.println();
//			}
//		}
		
		System.out.println(results("ec1"));

		System.out.println(meanVal("c1", "ec1", 3));
		
	}
	
	public double[] getUserScores(String user, int t){
		double scores[]={0,0,0,0};
		for (int i=0; i<elements.size();i++) {
			scores[i]=score(elements.get(i),user,t);
		}
		return scores;
	}
	
	public double[] getMeanScores(String context,int t){
		double scores[]={0,0,0,0};
		for (int i=0; i<elements.size();i++) {
			scores[i]=meanVal(elements.get(i),context,t);
		}
		return scores;
	}
	
	public double[] getGroupScores(String context,int t){
		double scores[]={0,0,0,0};
		for (int i=0; i<elements.size();i++) {
			scores[i]=grpScore(elements.get(i),context,t);
		}
		return scores;
	}
	
	private Vector<String> loader(String file,Vector<String> res){
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		Pattern comment=Pattern.compile("[ \t]*#.*$");
		Matcher match;
		try {
			br = new BufferedReader(new FileReader(file));
			String line;
			while((line=br.readLine())!=null){
				match=comment.matcher(line);
				line=match.replaceAll("");
				if(!line.equals("")){res.add(line);};
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e){
			e.printStackTrace();
		}
		return res;
	}
	
	private String results(String context){
		String res="";
		
		int linesize=65;
		
		res+="tx\t\t|";
		for(int t=0;t<periods;t++){
			res+=t+"\t|";
		}
		res+="\n";
		for(int t=0;t<linesize;t++){
			res+="-";
		}
		res+="\n";
		
		//scores d'interaction ...
		for(String elem:elements){
			for (String user : users) {
				res+="UIS("+elem+","+user+")\t|";
				for(int t=0;t<periods;t++){
					res+=Math.round(uiScore(elem, user, t)*1000)/1000.+"\t|";
				}
				res+="\n";
			}
		}
		for(int t=0;t<linesize;t++){
			res+="-";
		}
		res+="\n";
		
		
		for(String elem:elements){
			for (String user : users) {
				res+="UIS("+elem+","+user+")\t|";
				for(int t=0;t<periods;t++){
					double sum=0;
					for (String elm2 : elements) {
						sum+=uiScore(elm2, user, t);
					}
					res+=Math.round(uiScore(elem, user, t)/sum*1000)/10.+"%\t|";
				}
				res+="\n";
			}
		}
		
		for(int t=0;t<linesize;t++){
			res+="-";
		}
		res+="\n";
		
		//scores de localisation ...
		for(String elem:elements){
			for (String user : users) {
				res+="LcS("+elem+","+user+")\t|";
				for(int t=0;t<periods;t++){
					res+=Math.round(locScore(elem, user, t)*1000)/1000.+"\t|";
				}
				res+="\n";
			}
		}
		for(int t=0;t<linesize;t++){
			res+="-";
		}
		res+="\n";
		for(String elem:elements){
			for (String user : users) {
				res+="LcS("+elem+","+user+")\t|";
				for(int t=0;t<periods;t++){
					double sum=0;
					for (String elm2 : elements) {
						sum+=locScore(elm2, user, t);
					}
					res+=Math.round(locScore(elem, user, t)/sum*1000)/10.+"%\t|";
				}
				res+="\n";
			}
		}
		
		
		for(int t=0;t<linesize;t++){
			res+="-";
		}
		res+="\n";
		
		//scores combines ...
		for(String elem:elements){
			for (String user : users) {
				res+="Scr("+elem+","+user+")\t|";
				for(int t=0;t<periods;t++){
					res+=Math.round(score(elem, user, t)*1000)/1000.+"\t|";
				}
				res+="\n";
			}
		}
		
		for(int t=0;t<linesize;t++){
			res+="-";
		}
		res+="\n";
		for(String elem:elements){
			for (String user : users) {
				res+="Scr("+elem+","+user+")\t|";
				for(int t=0;t<periods;t++){
					double sum=0;
					for (String elm2 : elements) {
						sum+=score(elm2, user, t);
					}
					res+=Math.round(score(elem, user, t)/sum*1000)/10.+"%\t|";
				}
				res+="\n";
			}
		}
		
		for(int t=0;t<linesize;t++){
			res+="-";
		}
		res+="\n";
		
		
		//score moyen instantané...
		for(String elem:elements){
			res+="MVl("+elem+","+context+")\t|";
			for(int t=0;t<periods;t++){
				res+=Math.round(meanVal(elem,context,t)*1000)/1000.+"\t|";
			}
			res+="\n";
		}
		for(int t=0;t<linesize;t++){
			res+="-";
		}
		res+="\n";
		
		//score de groupe
		for(String elem:elements){
			res+="GRs("+elem+","+context+")\t|";
			for(int t=0;t<periods;t++){
				res+=Math.round(grpScore(elem,context,t)*1000)/1000.+"\t|";
			}
			res+="\n";
		}
		for(int t=0;t<linesize;t++){
			res+="-";
		}
		res+="\n";
		
		res+="somme GRs\t|";
		for(int t=0;t<periods;t++){	
			double somme=0;
			for(String elem:elements){
				somme+=grpScore(elem, context, t);
			}
			res+=""+(Math.round(somme)*1000)/1000.+"\t|";
		}
		res+="\n";
		
		res+="somme Mvl\t|";
		for(int t=0;t<periods;t++){	
			double somme=0;
			for(String elem:elements){
				somme+=meanVal(elem, context, t);
			}
			res+=""+(Math.round(somme)*1000)/1000.+"\t|";
		}
		res+="\n";
	
		return res;
		
	}
	
	//vérifié
	private double meanVal(String elem, String context,int t){
		double meanVal=0;
		if(users(context,t).size()!=0){
			for (String user : users(context,t)){
				meanVal+=(wUsr(elem,user,t)/sumwUsr(elem,context,t))*(score(elem,user,t)/sumScore(user,context,t));
			}
		}else{
			if(elems(context,t).size()!=0){
				meanVal=1./elems(context,t).size();
			}
		}
		return meanVal;
	}
	
	//verifie
	private double grpScore(String elem, String context,int t){
		double grpScore=0;
		if(t==0){grpScore=meanVal(elem,context, t);}
		else{
			double tmp=0;
			for(int j=1; j<=t;j++){
				//methode reccursive sur les scores de groupe
				tmp+=wHist(elem,context,t-j,t)/sumwHist(elem,context,t)*grpScore(elem,context,t-j);
				//methode reccursive sur les scores moyens instantannés
				//tmp+=wHist(elem,context,t-j,t)/sumwHist(elem,context,t)*meanVal(elem,context,t-j);
			}
			grpScore=(1-wBal(elem,context,t))*meanVal(elem,context,t)+wBal(elem,context,t)*tmp;
		}
		return grpScore;
	}
	
	//verifie
	private double score(String elem,String user, int t){
		if(elems(locState(user,t),t).contains(elem)){
			return wScore(elem,user,t)*(uiScore(elem,user,t)/sumUIScore(user,t))+(1-wScore(elem,user,t))*(locScore(elem,user,t)/sumLocScore(user,t));
		}
		return 0;
	}
	
	//verifie
	private Vector<String> elems(String context,int t){
		for (ContextElems ct : contextsElems) {
			if(ct.t==t && ct.context.equals(context)){
				return ct.elems;
			}
		}
		return new Vector<String>(); 
	}
	
	//vérifié
	private String locState(String user, int t){
		for (LocalContext ct : localContexts) {
			if(ct.t==t && ct.user.equals(user)){
				return ct.context;
			}
		}
		return "";
	}
	
	//vérifié
	private double wUsr(String elem,String user,int t){
		double tmp=0;
		for(int y=0;y<=t;y++){
			//System.out.println(user+", contexte actuel "+locState(user,t)+", contexte passé "+locState(user,y)+" à t"+y+"  "+users(locState(user,t),y).toString());
			if(users(locState(user,t),y).contains(user)){tmp++;
			}
		}
		return tmp;
	}
	
	//vérifié
	private double wHist(String elem,String context,int n, int x){
		double tmp=0;
		if((n-x)<=2 && n<x){tmp=1./(x-n);}
		return tmp;
	}
	
	//verifié
	private double wBal(String elem,String context,int t){
		double tmp=0;
		if(users(context,t).size()>0){tmp=(1-1./(users(context,t).size()));}
		return tmp;

	}
	
	//vérifié
	private double wScore(String elem,String user, int t){
		return 0.5;
	}
	
	private double locScore(String elem,String user, int t){
		double res=0;
		double eX=0;
		double eY=0;
		if(elems(locState(user, t),t).contains(elem)){
			for (ElemLoc elmloc : elemLocs) {
				if(elmloc.elem.equals(elem) && elmloc.t==t){
					eX=elmloc.locX;
					eY=elmloc.locY;
					break;
				}
			}
			for (Pause bp : breakPos(user,locState(user, t),t)) {
				res+=bp.time/Math.sqrt(Math.pow(bp.locX-eX,2)+Math.pow(bp.locY-eY,2));
			}
		}
		return res;
	}
	
	private Vector<Pause> breakPos(String user,String context,int t){
		//note .. le contexte n'est pas obligatoire ...
		for (BreakPos bps : breakPos) {
			if(bps.t==t && bps.user.equals(user)){
				return bps.pauses;
			}
		}
		return new Vector<Pause>();
	}
	
	private double uiScore(String elem,String user, int t){
		double res=0;
		double eX=0;
		double eY=0;
		if(elems(locState(user, t),t).contains(elem)){
		for (ElemLoc elmloc : elemScreenPos) {
			if(elmloc.elem.equals(elem) && elmloc.t==t){
				eX=elmloc.locX;
				eY=elmloc.locY;
				break;
			}
		}
		
		for(Pause mp:mouseHes(user,locState(user, t),t)){
			res+=mp.time/Math.sqrt(Math.pow(mp.locX-eX,2)+Math.pow(mp.locY-eY,2));
		}
		}
		return wView(user,t)*res;
	}
	
	public Vector<Pause> mouseHes(String user,String context,int t){
		for (BreakPos bps: mouseHes) {
			if(bps.t==t && bps.user.equals(user)){
				return bps.pauses;
			}
		}
		return new Vector<Pause>();
	}
	
	
	//verifié
	private double wView(String user, int t){
		//!!!! IL FAUDRAIT FAIRE UNE SOMME DES POIDS ET DONNER UNE IMPORTANCE RELATIVE !!!!!!
		for (View v : views) {
			if(v.user.equals(user) && v.t==t){
				return v.weight;
			}
		}
		return 1;
	}
	
	
	//verifie
	private double sumUIScore(String user, int t){
		double tmp=0;
		for (String elem : elems(locState(user, t),t)) {
			tmp+=uiScore(elem, user, t);
		}
		if(tmp==0){tmp=1;}
		return tmp;
	}
	//verifie
	private double sumLocScore(String user, int t){
		double tmp=0;
		for (String elem : elems(locState(user, t),t)) {
			tmp+=locScore(elem, user, t);
		}
		if(tmp==0){tmp=1;}
		return tmp;
	}
	
	//verifié
	private double sumwUsr(String elem,String context,int t){
		double tmp=0;
		for (String user : users(context,t)) {
			tmp+=wUsr(elem, user, t);
		}
		if(tmp==0){tmp=1;}
		return tmp;
	}
	
	//vérifié
	private double sumScore(String user,String context,int t){
		double tmp=0;
		for (String elem : elems(context,t)) {
			tmp+=score(elem, user, t);
		}
		if(tmp==0){tmp=1;}
		return tmp;
	}
	
	//verifié
	private double sumwHist(String elem, String context, int t){
		double tmp=0;
		for (int k=1;k<=t;k++){
			tmp+=wHist(elem, context, t-k, t);
		}
		if(tmp==0){tmp=1;}
		return tmp;
	}
	
	//verifié
	//ensemble des utilisateurs à t_x
	private Vector<String> users(String context,int t){
		Vector<String> tmp=new Vector<String>();
		for(LocalContext ct : localContexts){
			if(ct.t==t && ct.context.equals(context)){
				tmp.add(ct.user);
			}
		}
		return tmp;
	}
	
	class ScorList extends Vector<Scor>{
		private static final long serialVersionUID = 1L;

		public ScorList getUser(String user){
			ScorList tmp= new ScorList();
			for (Scor score : this) {
				if(score.user.equals(user)){
					tmp.add(score);
				}
			}
			return tmp;
		}
		public ScorList getTime(int t){
			ScorList tmp= new ScorList();
			for (Scor score : this) {
				if(score.t==t){
					tmp.add(score);
				}
			}
			return tmp;
		}
		public ScorList getElement(String element){
			ScorList tmp= new ScorList();
			for (Scor score : this) {
				if(score.elem.equals(element)){
					tmp.add(score);
				}
			}
			return tmp;
		}
		
		public String toString(){
			String tmp="";
			for (Scor score : this) {
				tmp+=score.toString();
			}
			return tmp; 
		}
		
	}
	
	//classe interne pour la valeur d'un score
	class Scor{
		public String user,elem;
		public int t;
		public double value;
		
		public Scor(String elem,String user,int t,double value){
			this.value=value;
			this.user=user;
			this.elem=elem;
			this.t=t;
		}
		
		public String toString(){
			return "("+elem+", "+user+", t"+t+"): "+value+"\n";
		}
	}
	
	//classe interne pour la représentation des éléments d'un contexte à un instant t
	class ContextElems{
		public String context;
		public Vector<String> elems=new Vector<String>();
		public int t;
		public ContextElems(String context,int t){
			this.context=context;
			this.t=t;
		}
		public void add(String elem){
			elems.add(elem);
		}
		public String toString(){
			return "("+context+", t"+t+"): "+elems.toString()+"\n";
		}
	}
	class LocalContext{
		public String user,context;
		public int t;
		public LocalContext(String user,int t){
			this.user=user;
			this.t=t;
		}
		public void set(String context){
			this.context=context;;
		}
		public String toString(){
			return "("+user+", t"+t+"): "+context+"\n";
		}
	}
	
	class ElemLoc{
		public String elem;
		public int locX,locY,t;
		public ElemLoc(String elem, int t) {
			this.elem=elem;
			this.t=t;
		}
		public void set(int locX,int locY){
			this.locX=locX;
			this.locY=locY;
		}
		public String toString(){
			return "("+elem+","+t+":("+locX+","+locY+"))";
		}
	}
	
	class BreakPos{
		public String user;
		public Vector<Pause> pauses;
		public int t;
		public BreakPos(String user,int t) {
			this.user=user;
			this.t=t;
		}
		public void set(Vector<Pause> pauses){
			this.pauses=pauses;
		}
		public String toString(){
			String res="("+user+","+t+":";
			for (Pause p: pauses) {
				res+=p.toString();
			}
			return res+")";
		}
	}
	class Pause{
		public int locX,locY,time;
		public Pause(int locX,int locY,int time) {
			this.locX=locX;
			this.locY=locY;
			this.time=time;
		}
		public String toString(){
			return "[("+locX+","+locY+"),"+time+"]";
		}
	}
	
	class View{
		public String user;
		public int t;
		public double weight;
		public View(String user,int t) {
			this.user=user;
			this.t=t;
		}
		public void set(double weight){
			this.weight=weight;
		}
	}
	
}