package model;

import javax.swing.event.EventListenerList;

import STATICS.Helper;

public abstract class Model implements ModelInterface,Runnable{
	
	protected EventListenerList listeners;
	private boolean run=true;
	
	public Model(){
		listeners=new EventListenerList();
		Thread tmp=new Thread(this);
		tmp.setName("Model");
		tmp.start();
	}
	
	public void dispose(){run=false;}
	
	public void addListener(ModelListener listener){listeners.add(ModelListener.class,listener);}
	public void removeListener(ModelListener listener){listeners.remove(ModelListener.class,listener);}
	
	public void fireModelEvent(ModelEvent ev){
		for (ModelListener listener : listeners.getListeners(ModelListener.class)) {
			listener.update(ev);
		}
	}
	
	@Override
	public void run() {
		while(run){
//			System.out.println("Model alive ...");
			Helper.sleep(2000);
		}
	}
	
}
