package view;

import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JFrame;
import javax.swing.event.EventListenerList;

import STATICS.Helper;


public abstract class View extends JFrame implements ViewInterface,WindowListener,Runnable{
	
	private static final long serialVersionUID = 1L;
	private boolean run=true;
	protected EventListenerList listeners;
	
	
	public View() {
		listeners=new EventListenerList();
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		addWindowListener(this);
		Thread tmp=new Thread(this);
		tmp.setName("View");
		tmp.start();
	}

	public void addListener(ViewListener listener){listeners.add(ViewListener.class,listener);}
	public void removeListener(ViewListener listener){listeners.remove(ViewListener.class,listener);}
	
	public void fireViewEvent(ViewEvent ev){
		for (ViewListener listener : listeners.getListeners(ViewListener.class)) {
			listener.update(ev);
		}
	}
	
	@Override
	public void run(){
		while(run){
//			System.out.println("View alive ...");
			Helper.sleep(2000);
		}
	}
	
	@Override
	public void windowActivated(WindowEvent e) {}
	@Override
	public void windowClosed(WindowEvent e) {run=false;}
	@Override
	public void windowDeactivated(WindowEvent e) {}
	@Override
	public void windowDeiconified(WindowEvent e){}
	@Override
	public void windowIconified(WindowEvent e){}
	@Override
	public void windowOpened(WindowEvent e) {}
	
}
