package controler.user;


import java.awt.geom.Point2D;

import view.View;
import view.ViewEvent;
import view.user.UserView;
import view.user.UserViewEvent;

import model.Model;
import model.ModelEvent;
import model.user.BreakPos;
import model.user.User;
import model.user.UserModel;
import model.user.UserModelEvent;
import model.user.exceptions.NoCurrentUserSetException;

import controler.Controler;
import controler.ControlerEvent;

public class UserControler extends Controler{
	
	public UserControler(){
		super();
	}

	//évènements en provenance de la vue
	@Override
	public void update(ViewEvent ev){
		UserViewEvent userEv=(UserViewEvent)ev;
		switch (userEv.getType()) {
			case CurrentTime_updated:
				setModelProperty("CurrentTime", userEv.getNewValue());break;
			case View_closed://liberer l'espace et fermer la fenetre
				removeView((View)userEv.getSource());break;
			case UserName_updated:
				setModelProperty("UserName", (String)userEv.getNewValue());break;
			case CurrentUser_updated:
				setModelProperty("CurrentUser", userEv.getNewValue());break;
			case RemoveUser_updated:
				if(userEv.getNewValue()!=null){setModelProperty("RemoveUser",userEv.getNewValue());}break;
			case AddNewUser_updated:
				setModelProperty("AddNewUser",(String)userEv.getNewValue());break;
			case CopyCurrentUser_updated:
				setModelProperty("CopyUser",(String)userEv.getNewValue());break;
			case AddCurrentUserBreak_updated:
				setModelProperty("AddBreakPosAtCurrentTime",(Point2D.Double)userEv.getNewValue());break;
			case CurrentUserBreakLocation_updated:
				setModelProperty("BreakPosLocation",(Point2D.Double)userEv.getNewValue());break;
			case CurrentUserBreakDuration_updated:
				setModelProperty("BreakPosDuration",(Double)userEv.getNewValue());break;
			case CurrentBreak_updated:
				setModelProperty("CurrentBreak",(BreakPos)userEv.getNewValue());break;
			case RemoveCurrentBreakPos_updated:
				setModelProperty("RemoveCurrentBreakPos");break;
			case RemoveBreakPos_updated:
				setModelProperty("RemoveBreakPos",(BreakPos)userEv.getNewValue());break;
			default:break;
		}
	}

	//évènements en provenance du modèle
	@Override
	public void update(ModelEvent ev){
		UserModelEvent userEv=(UserModelEvent)ev;
		switch (userEv.getType()) {
			case MapImage_set:
				setViewProperty("MapImage",userEv.getNewValue());break;
			case CurrentTime_set:
				setViewProperty("CurrentTime", (Double)userEv.getNewValue());break;
			case Range_set:
				setViewProperty("Range",(Double)userEv.getNewValue());break;
			case UpdateInterval_set:
				setViewProperty("UpdateInterval",(Double)userEv.getNewValue());break;
			case CurrentUser_set:
				setViewProperty("CurrentUser", ((User)ev.getNewValue()).getName());break;
			case NoMoreUsers_set:break;
			case BreakPosAdded_set:
				setViewProperty("AddBreakPos",(BreakPos)ev.getNewValue());break;
			case UserRename_set:
				setViewProperty("UserName",(String)ev.getOldValue(),(String)((User)ev.getNewValue()).getName());break;
			case AddNewUser_set:
				setViewProperty("AddNewUser",(String)((User)ev.getNewValue()).getName());break;
				//il faut ensuite initialiser les pauses ...
			case RemoveUser_set:
				setViewProperty("RemoveUser",(String)((User)ev.getNewValue()).getName());break;
			case BreakPosLocation_set:
				setViewProperty("BreakPosLocation",(BreakPos)ev.getNewValue());break;
			case BreakPosDuration_set:
				setViewProperty("BreakPosDuration",(BreakPos)ev.getNewValue());break;
			case RemoveBreakPos_set:
				setViewProperty("RemoveBreakPos",(BreakPos)ev.getNewValue());break;
			case RemoveCurrentBreakPos_set:
				setViewProperty("RemoveCurrentBreakPos",(BreakPos)ev.getNewValue());break;
			default:break;
		}
	}

	//évènements en provenance d'autres (éventuels) controleurs
	@Override
	public void update(ControlerEvent ev){}
	
	//initialisation des vues lors de l'ajout des models 
	@Override
	public void initView(View view, Model model) {
		//getter et setter automatic matching ..
		autoinitView(view, model);
		//puis on y vas a la main pour le reste ..
		String modelType=model.getClass().getSimpleName();
		String viewType=view.getClass().getSimpleName();
		if (modelType.equals("UserModel") && viewType.equals("UserView")){
			for (User user : ((UserModel)model).getUsers()) {
				((UserView)view).setAddNewUser((String)user.getName());
			}
			try {setViewProperty("CurrentUser",((UserModel)model).getCurrentUser().getName());
			} catch (NoCurrentUserSetException e) {e.printStackTrace();}	
		} else	{ }
	}


}
