package model.user;
import java.util.Vector;

import model.ModelEvent;
import model.user.exceptions.BreakOverlaps;
import model.user.exceptions.BreakPosNotFound;
import model.user.exceptions.NoBreakPosAtCurrentTime;

import sun.text.normalizer.UProperty;


public class User{
	private String name;
	private Vector<MouseHes> mouseHesitations=new Vector<MouseHes>();
	private Vector<BreakPos> breakPos=new Vector<BreakPos>();
	
	private BreakPos currentBreak=null;
	
	public User(String name){
		super();
		this.name=name;
	}
	
	public User(User currentUser, String name) {
		this(name);
		System.err.println("Pas de recopie encore");
	}

	//setters
	public void setName(String name) {
		if(name.length()<=8){this.name = name;}
	}
	
	public void setCurrentBreakPos(double currentTime) throws NoBreakPosAtCurrentTime{
		for (BreakPos pos : breakPos) {if(pos.contain(currentTime)){currentBreak=pos;return;}}
		currentBreak=null;
		throw new NoBreakPosAtCurrentTime();
	}
	
	public void addBreakPos(double x,double y,double start,double end,String context) throws BreakOverlaps{
		BreakPos tmp=new BreakPos(x,y,start,end,context);
		for (BreakPos pos : breakPos) {
			//les pauses ne doivent pas se chevaucher ..
			if(	(tmp.getStart()>=pos.getStart() && tmp.getStart()<=pos.getEnd()) ||
				(tmp.getEnd()<=pos.getEnd() && tmp.getEnd()>=pos.getStart()) ||
				(tmp.getEnd()>=pos.getEnd() && tmp.getStart()<=pos.getStart())){
				throw new BreakOverlaps();
			}	
		}
		breakPos.add(tmp);
	}
	
	public void removeBreakPos(BreakPos pos) throws BreakPosNotFound{
		if(currentBreak!=pos){
			if(breakPos.contains(pos)){
				breakPos.remove(pos);
			}else{
				throw new BreakPosNotFound();
			}
		}else{
			removeCurrentBreakPos();
		}
	}
	public void removeCurrentBreakPos() throws BreakPosNotFound{
		if(currentBreak!=null && breakPos.contains(currentBreak)){
			breakPos.remove(currentBreak);
			currentBreak=null;
		}else{
			throw new BreakPosNotFound();
		}
	}
	
	
	
	//getters
	public String getName(){return name;}
	public BreakPos getCurrentBreak(){
		return currentBreak;
	}
	public Vector<BreakPos> getBreaks(){return breakPos;}
	
	
	public void addMouseHes(double x,double y,double time,double duration,String context){
		double t=0;
		int index=0;
		MouseHes tmp=new MouseHes(x,y,time,Math.min(time, duration),context);
		if(!mouseHesitations.isEmpty()){
			mouseHesitations.add(mouseHesitations.lastElement());
			do{
				t=mouseHesitations.get(index).time;
				index++;
			}while(t<tmp.time && index<mouseHesitations.size());
			tmp.duration=Math.min(tmp.duration, (tmp.time-mouseHesitations.get(index-1).time));
			mouseHesitations.add(index-1, tmp);
			mouseHesitations.remove(mouseHesitations.size()-1);
		}else{
			mouseHesitations.add(tmp);
		}
	}
	
}
